#ifndef __DEFCONF_H
#include "defconf.h"
#endif
/*
   This file was hacked for kmtar for WIN32
                                    at 1996-05-06.
                                    by tantan SGL00213@niftyserve.or.jp 
*/
/* zip.c -- compress files to the gzip or pkzip format
 * Copyright (C) 1992-1993 Jean-loup Gailly
 * This is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License, see the file COPYING.
 */

#ifdef RCSID
static char rcsid[] = "$Id: ZIP.C,v 1.1.1.1 1999/12/19 06:04:59 tsuneo Exp $";
#endif

#include <ctype.h>
#include <stdlib.h>
#include <sys/types.h>

#include "tailor.h"
#include "gzip.h"
#include "crypt.h"
#include "lzw.h"
#include "misc.h"

#ifdef HAVE_UNISTD_H
#  include <unistd.h>
#endif
#ifndef NO_FCNTL_H
#  include <fcntl.h>
#endif

#ifndef	DYN_ALLOC
DECLARE(uch, inbuf,  INBUFSIZ +INBUF_EXTRA);
DECLARE(uch, window, 2L*WSIZE);
#endif

DECLARE(uch, outbuf, OUTBUFSIZ+OUTBUF_EXTRA);
DECLARE(ush, d_buf,  DIST_BUFSIZE);

/*DECLARE(uch, zip_write_buf, 3L*WSIZE);*/
#ifndef MAXSEG_64K
    DECLARE(ush, tab_prefix, 1L<<BITS);
#else
    DECLARE(ush, tab_prefix0, 1L<<(BITS-1));
    DECLARE(ush, tab_prefix1, 1L<<(BITS-1));
#endif

local ulg crc;       /* crc on uncompressed file data */
long header_bytes;   /* number of bytes in gzip header */
int zip_write_end =0;   /* end of write flag */
int lack_of_data = 0;  /* reset flag */
ulg n_total=0;
uch *zip_write_buf=NULL;
/* ===========================================================================
 * Deflate in to out.
 * IN assertions: the input and output buffers are cleared.
 *   The variables time_stamp and save_orig_name are initialized.
 */
int zip_start(int h)
{
    uch  flags = 0;         /* general purpose bit flags */
    ush  attr = 0;          /* ascii/binary flag */
    ush  deflate_flags = 0; /* pkzip -es, -en or -ex equivalent */

    zip_write_end =0;
    /* Allocate all global buffers (for DYN_ALLOC option) */
#ifdef	DYN_ALLOC
    if (inbuf == NULL)
    ALLOC(uch, inbuf,  INBUFSIZ +INBUF_EXTRA);
    if (outbuf == NULL)
    ALLOC(uch, outbuf, OUTBUFSIZ+OUTBUF_EXTRA);
    if (d_buf == NULL)
    ALLOC(ush, d_buf,  DIST_BUFSIZE);
    if (window == NULL)
    ALLOC(uch, window, 2L*WSIZE);
#endif

    if (zip_write_buf == NULL)
#if defined(WIN32)
    zip_write_buf = (uch *)xmalloc(3L*WSIZE);
    if (zip_write_buf == NULL)
    	fatal("zip","Out of memory");
#endif

#ifdef	DYN_ALLOC
#if defined(WIN32)
    if (tab_prefix == NULL){
#endif
#ifndef MAXSEG_64K
    ALLOC(ush, tab_prefix, 1L<<BITS);
#else
    ALLOC(ush, tab_prefix0, 1L<<(BITS-1));
    ALLOC(ush, tab_prefix1, 1L<<(BITS-1));
#endif
	}
#endif

/*    fprintf(stderr,"zip_write_buf %p\n",zip_write_buf);*/
    /* And get to work */
    clear_bufs(); /* clear input and output buffers */

    ofd = h;
    outcnt = 0;

    /* Write the header to the gzip file. See algorithm.doc for the format */

    method = DEFLATED;
    put_byte(GZIP_MAGIC[0]); /* magic header */
    put_byte(GZIP_MAGIC[1]);
    put_byte(DEFLATED);      /* compression method */

    put_byte(flags);         /* general flags */
    put_long(gzip_time_stamp);

    /* Write deflated file to zip file */
    crc = updcrc(0, 0);

    bi_init(ofd);
    ct_init(&attr, &method);
    lm_init(level, &deflate_flags);

    put_byte((uch)deflate_flags); /* extra flags */
    put_byte(OS_CODE);            /* OS identifier */

    header_bytes = (long)outcnt;

    return 0;
}

extern void win_init(void);

void zip_end(void)
{

   extern uch Vflag;
   void zip_end_flush(void);
   int get_zip_write_entry_flag(void);
/*    fprintf(stderr,"\azip_end\n");*/


    zip_write_end =1;
    zip_end_flush();
    (void)deflate();

    /* Write the crc and uncompressed size */
    put_long(crc);
    put_long(isize);
    header_bytes += 2*sizeof(long);

    flush_outbuf();
    FREE(outbuf);
    FREE(d_buf);
#ifndef MAXSEG_64K
    FREE(tab_prefix);
#else
    FREE(tab_prefix0);
    FREE(tab_prefix1);
#endif
    free(zip_write_buf);
    
    if (Vflag)
      printf("-------------------\nFrom %ld to %ld Compressed.\n",
      n_total,bytes_out);

}


/* ===========================================================================
 * Read a new buffer from the current input buffer, perform end-of-line
 * translation, and update the crc and input file size.
 * IN assertion: size >= 2 (for end-of-line translation)
 */
#if defined(WIN32)
uch *read_p,*write_p;  /* read and write pointer */
int zb_size=0;    /* current data size */
int file_read(char *buf, unsigned size)
{
    unsigned len;

    Assert(insize == 0, "inbuf not empty");

/*    fprintf(stderr,"size %d  zb_size %d\n",size ,  zb_size);*/
    lack_of_data = 0;  /* reset flag */
    if ((int)size <= zb_size){
       memcpy(buf,read_p,size);
       read_p += size;
       zb_size -= size;
       len = size;
    }else if (!zip_write_end){
       lack_of_data=1;
       return 0;
    }else{
       memcpy(buf,read_p,zb_size);
       read_p += zb_size;
       len = zb_size;
       zb_size = 0;
    }
    if (len == (unsigned)(-1) || len == 0) return (int)len;

    crc = updcrc((uch*)buf, len);
    isize += (ulg)len;
    return (int)len;
}

static zip_write_entry_flag=0;

int zip_write(int h,char *buf,int size)
{
    // static int entry_flag=0;

/*    fprintf(stderr,"--size %d\n",size);*/
    n_total += size;

    if (!zip_write_entry_flag){
    	zip_start(h);
    	read_p = write_p =zip_write_buf;
    	zip_write_entry_flag=1;
    }

    if (write_p+size >zip_write_buf+3L*WSIZE){
    	memmove(zip_write_buf,read_p,zb_size);
    	read_p = zip_write_buf;
    	write_p = zip_write_buf+zb_size;
    }
    memcpy(write_p,buf,size);
    zb_size += size;
    write_p += size;
    

    if (zip_write_entry_flag == 1){
         win_init();
         if (lack_of_data)
            return 0;
         zip_write_entry_flag++;
    }

    (void)deflate();
    return 0;
}
#endif /* WIN32 */

#ifdef DLL
void zip_static_init(void)
{
	crc=0;       /* crc on uncompressed file data */
	header_bytes=0;   /* number of bytes in gzip header */
	zip_write_end =0;   /* end of write flag */
	lack_of_data = 0;  /* reset flag */
	n_total=0;
	zip_write_buf=NULL;

	read_p=NULL,write_p=NULL;  /* read and write pointer */
	zb_size=0;    /* current data size */

	zip_write_entry_flag=0;
}
#endif